# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b0"
os.chdir("/Users/was/notebook/misc/worksheets/admin/270/cells/14")
sage.server.notebook.interact.SAGE_CELL_ID=14
__SAGE_t__=cputime()
__SAGE_w__=walltime()
@interact
def _(f = sin(x*cos(x)), order=(ellipsis_range(Integer(1),Ellipsis,Integer(5))), x0=(Integer(1),(-Integer(1),Integer(5)))):
    p   = plot(f,-Integer(1),Integer(5), thickness=Integer(2))
    dot = point((x0,f(x0)),pointsize=Integer(80),rgbcolor=(Integer(1),Integer(0),Integer(0)))
    ft = f.taylor(x,x0,order)
    pt = plot(ft,-Integer(1), Integer(5), color='green', thickness=Integer(2))
    html('$f(x)\;=\;%s$'%latex(f))
    html('$\hat{f}(x;%s)\;=\;%s+\mathcal{O}(x^{%s})$'%(x0,latex(ft),order+Integer(1)))
    show(p + pt + dot, ymin=p.ymin(), ymax=p.ymax())
print "CPU time: %.2f s,  Wall time: %.2f s"%(cputime(__SAGE_t__), walltime(__SAGE_w__))

print "e0"
