# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b1"
os.chdir("/Users/was/notebook/misc/worksheets/admin/270/cells/97")
sage.server.notebook.interact.SAGE_CELL_ID=97
__SAGE_t__=cputime()
__SAGE_w__=walltime()
var('u,v')
plots = ['Two Interlinked Tori', 'Star of David', 'Double Heart',
         'Heart', 'Green bowtie', "Boy's Surface", "Maeder's Owl",
         'Cross cap']


plots.sort()

@interact
def _(example=selector(plots, buttons=True, nrows=Integer(2)),
      tachyon=("Raytrace", True), frame = ('Frame', False),
      opacity=(Integer(1),(RealNumber('0.1'),Integer(1)))):
    url = ''
    if example == 'Two Interlinked Tori':
        f1 = (Integer(4)+(Integer(3)+cos(v))*sin(u), Integer(4)+(Integer(3)+cos(v))*cos(u), Integer(4)+sin(v))
        f2 = (Integer(8)+(Integer(3)+cos(v))*cos(u), Integer(3)+sin(v), Integer(4)+(Integer(3)+cos(v))*sin(u))
        p1 = parametric_plot3d(f1, (u,Integer(0),Integer(2)*pi), (v,Integer(0),Integer(2)*pi), color="red", opacity=opacity)
        p2 = parametric_plot3d(f2, (u,Integer(0),Integer(2)*pi), (v,Integer(0),Integer(2)*pi), color="blue",opacity=opacity)
        P = p1 + p2
    elif example == 'Star of David':
        f_x = cos(u)*cos(v)*(abs(cos(Integer(3)*v/Integer(4)))**Integer(500) + abs(sin(Integer(3)*v/Integer(4)))**Integer(500))**(-Integer(1)/Integer(260))*(abs(cos(Integer(4)*u/Integer(4)))**Integer(200) + abs(sin(Integer(4)*u/Integer(4)))**Integer(200))**(-Integer(1)/Integer(200))
        f_y = cos(u)*sin(v)*(abs(cos(Integer(3)*v/Integer(4)))**Integer(500) + abs(sin(Integer(3)*v/Integer(4)))**Integer(500))**(-Integer(1)/Integer(260))*(abs(cos(Integer(4)*u/Integer(4)))**Integer(200) + abs(sin(Integer(4)*u/Integer(4)))**Integer(200))**(-Integer(1)/Integer(200))
        f_z = sin(u)*(abs(cos(Integer(4)*u/Integer(4)))**Integer(200) + abs(sin(Integer(4)*u/Integer(4)))**Integer(200))**(-Integer(1)/Integer(200))
        P = parametric_plot3d([f_x, f_y, f_z], (u, -pi, pi), (v, Integer(0), Integer(2)*pi),opacity=opacity)
    elif example == 'Double Heart':
        f_x = ( abs(v) - abs(u) - abs(tanh((Integer(1)/sqrt(Integer(2)))*u)/(Integer(1)/sqrt(Integer(2)))) + abs(tanh((Integer(1)/sqrt(Integer(2)))*v)/(Integer(1)/sqrt(Integer(2)))) )*sin(v)
        f_y = ( abs(v) - abs(u) - abs(tanh((Integer(1)/sqrt(Integer(2)))*u)/(Integer(1)/sqrt(Integer(2)))) - abs(tanh((Integer(1)/sqrt(Integer(2)))*v)/(Integer(1)/sqrt(Integer(2)))) )*cos(v)
        f_z = sin(u)*(abs(cos(Integer(4)*u/Integer(4)))**Integer(1) + abs(sin(Integer(4)*u/Integer(4)))**Integer(1))**(-Integer(1)/Integer(1))
        P = parametric_plot3d([f_x, f_y, f_z], (u, Integer(0), pi), (v, -pi, pi),opacity=opacity)
    elif example == 'Heart':
        f_x = cos(u)*(Integer(4)*sqrt(Integer(1)-v**Integer(2))*sin(abs(u))**abs(u))
        f_y = sin(u) *(Integer(4)*sqrt(Integer(1)-v**Integer(2))*sin(abs(u))**abs(u))
        f_z = v
        P = parametric_plot3d([f_x, f_y, f_z], (u, -pi, pi), (v, -Integer(1), Integer(1)), frame=False, color="red",opacity=opacity)
    elif example == 'Green bowtie':
        f_x = sin(u) / (sqrt(Integer(2)) + sin(v))
        f_y = sin(u) / (sqrt(Integer(2)) + cos(v))
        f_z = cos(u) / (Integer(1) + sqrt(Integer(2)))
        P = parametric_plot3d([f_x, f_y, f_z], (u, -pi, pi), (v, -pi, pi), frame=False, color="green",opacity=opacity)
    elif example == "Boy's Surface":
        url = "http://en.wikipedia.org/wiki/Boy's_surface"
        fx = Integer(2)/Integer(3)* (cos(u)* cos(Integer(2)*v) + sqrt(Integer(2))* sin(u)* cos(v))* cos(u) / (sqrt(Integer(2)) - sin(Integer(2)*u)* sin(Integer(3)*v))
        fy = Integer(2)/Integer(3)* (cos(u)* sin(Integer(2)*v) - sqrt(Integer(2))* sin(u)* sin(v))* cos(u) / (sqrt(Integer(2)) - sin(Integer(2)*u)* sin(Integer(3)*v))
        fz = sqrt(Integer(2))* cos(u)* cos(u) / (sqrt(Integer(2)) - sin(Integer(2)*u)* sin(Integer(3)*v))
        P = parametric_plot3d([fx, fy, fz], (u, -Integer(2)*pi, Integer(2)*pi), (v, Integer(0), pi), plot_points = [Integer(90),Integer(90)], frame=False, color="orange",opacity=opacity)
    elif example == "Maeder's Owl":
        fx = v *cos(u) - RealNumber('0.5')* v**Integer(2) * cos(Integer(2)* u)
        fy = -v *sin(u) - RealNumber('0.5')* v**Integer(2) * sin(Integer(2)* u)
        fz = Integer(4) *v**RealNumber('1.5') * cos(Integer(3) *u / Integer(2)) / Integer(3)
        P = parametric_plot3d([fx, fy, fz], (u, -Integer(2)*pi, Integer(2)*pi), (v, Integer(0), Integer(1)),plot_points = [Integer(90),Integer(90)], frame=False, color="purple",opacity=opacity)
    elif example =='Cross cap':
        url = 'http://en.wikipedia.org/wiki/Cross-cap'
        fx = (Integer(1)+cos(v))*cos(u)
        fy = (Integer(1)+cos(v))*sin(u)
        fz = -tanh((Integer(2)/Integer(3))*(u-pi))*sin(v)
        P = parametric_plot3d([fx, fy, fz], (u, Integer(0), Integer(2)*pi), (v, Integer(0), Integer(2)*pi), frame=False, color="red",opacity=opacity)
    else:
        print "Bug selecting plot?"
        return


    html('<h2>%s</h2>'%example)
    if url:
        html('<h3><a target="_new" href="%s">%s</a></h3>'%(url,url))
    show(P, viewer='tachyon' if tachyon else 'jmol', frame=frame)
print "CPU time: %.2f s,  Wall time: %.2f s"%(cputime(__SAGE_t__), walltime(__SAGE_w__))

print "e1"
